#include "macierz.h"
#include <stdlib.h>
#include <stdio.h>

/* Funkcja tworzy (alokuje pamiec) macierz o podanej liczbie wierszy 'w' i kolumn 'k'. Wartoscia zwracana jest adres macierzy: wskaznik do dablicy zawierajacej adresy kolejnych wierszy macierzy.  */
float **utworz_macierz(int w, int k)
{
   float **m;
   int i;
   m = (float **) malloc(w * sizeof(float*));
   if(m == NULL) return NULL;
   for(i=0 ; i<w ; i++)
   {
      m[i] = (float *) malloc(k *sizeof(float));
      if(m[i]==NULL) 
      {
         /*  sprzatanie juz przydzielonej pamieci */
         zwolnij_macierz(m,i);
         return NULL;
      }
   }
   return m;
}
/*  Funkcja wyswietla macierz m o podanych wymiarach (w i k).
 *  Zmienna 'm' jest adresem poczatku macierzy (tablicy zawierajacej adresy do kolejnych wierszy macierzy). Zmienna 'w' to liczba wierszy i odpowiednio 'k' - to liczba kolumn.*/
void wyswietl_macierz(float **m,int w,int k)
{
   int i,j;
   for(i=0 ; i<w ; i++)
   {
      for(j=0 ; j<k ; j++)
         printf(" %6.1f", *(*(m+i)+j) );
      printf("\n");
   }
}

/*  Funkcja wczytje wszystkie alementy macierzy ze standardowego wejscia (z klawiatury). Argementami sa: 'm' - adres (wskaznik) do macierzy, 'w' -liczba wierszy, 'k' - liczba kolumn.  Wartoscia zwracana jest adres do macierzy o zmodyfikowanych w ten sosob elementach. */
float** wczytaj_macierz(float **m,int w,int k)
{
   int i,j;
   for(i=0 ; i<w ; i++)
   {
      for(j=0 ; j<k ; j++)
      {
         printf(" [%d,%d] = ", i,j);
         scanf("%f",*(m+i)+j); 
      }
   }
   return m;
}


/* Funkcja zwalnia pamiec zajeta przez macierz 'm'.
 * Zmienna 'w' okresla liczbe wierszy.*/
void zwolnij_macierz(float **m, int w)
{
	while(--w > 0) free(*(m+w));
   free(m);
}







